/**
* Explain how to use the WriteMoreAnalogOutput function
**/
#include "stdafx.h"

/* entry point */
int _tmain( int /*argc*/, _TCHAR* /*argv[]*/ )
{
	INT returnValue = 0;
	HANDLE boardHandle = NULL;
	ULONG readValue = 0;
	
	BYTE channels[PCI3116_ANALOG_OUTPUT_NUMBER] = {0};
	BYTE polarity[PCI3116_ANALOG_OUTPUT_NUMBER] = {0};
	WORD values[PCI3116_ANALOG_OUTPUT_NUMBER] = {0};

	/* open a board */
	returnValue = OpenBoard(&boardHandle);
	if (returnValue != 0)
	{
		printf("Error %d opening the board \n", returnValue);
		_getch();
		return -1;
	}

	/* display some useful informations */
	printf("\n");
	printf("* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\n");
	printf("* This sample will write on the analog outputs of the board.\n");
	printf("* You can configure the value of each analog output channel.\n");
	printf("* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\n\n");

	/* initialize the channels */
	for ( int i = 0 ; i < PCI3116_ANALOG_OUTPUT_NUMBER ; i++ )
	{	
		printf("Configure the output %i \n", i);

		/* set the index */
		channels[i] = (BYTE) i;

		/* ask the polarity */
		ReadUlong("  - Select the polarity (0: Unipolar, 1: Bipolar) ", 0, 1, &readValue );
		switch ( readValue )
		{
			case 0:
				polarity[i] = PCI3116_OUTPUT_MODE_UNIPOLAR;
				/* ask the output value */
				ReadUlong("  - Select the output value (Unipolar: 0 to 2047) ", 0, 2047, &readValue);
				values[i] = (WORD) readValue;
				break;
			case 1:
				polarity[i] = PCI3116_OUTPUT_MODE_BIPOLAR;
				/* ask the output value */
				ReadUlong("  - Select the output value (Bipolar: 0 to 4095) ", 0, 4095, &readValue);
				values[i] = (WORD) readValue;
				break;
		}
	}

	/* write the analog outputs */
	returnValue = i_PCI3116_WriteMoreAnalogOutputs(boardHandle,
		PCI3116_ANALOG_OUTPUT_NUMBER,
		channels,
		polarity,
		values );

	if ( returnValue != 0 )
	{
		printf("Error %d in i_PCI3116_WriteMoreAnalogOutputs \n", returnValue);
	}
	else
	{
		printf("i_PCI3116_WriteMoreAnalogOutputs OK \n");
	}

	/* close the board */
	returnValue = i_PCI3116_CloseBoard(boardHandle);
	if (returnValue != 0)
	{
		printf("Error %d in i_PCI3116_CloseBoard \n", returnValue);
	}
	else
	{
		printf("i_PCI3116_CloseBoard OK \n");
	}

	/* exit */
	printf("\n Press any key to exit the sample ...");
	_getch();

	return 0;
}
